//
//  ChosePersonViewController.m
//  XFFruit
//
//  Created by 陈俊俊 on 15/8/6.
//  Copyright (c) 2015年 Xummer. All rights reserved.
//

#import "ChosePersonViewController.h"
#import "SurveyUser.h"
#import "User.h"
#define TopMargin 50
#define TableHeight 50
@interface ChosePersonViewController ()
{
}
@end

@implementation ChosePersonViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.currentPage = 0;
    self.tableStr = GXF_BASECLASS_USER;
    self.tableView.header.lastUpdatedTimeKey = ChoosePersonUpdateDate;
    self.title = @"选择人员";
    [self fetchDataList:@"" tableStr:GXF_BASECLASS_USER];
}

- (void)getBaseDataFromServerWithStartDate:(NSString *)startDate{
    __weak typeof(self)weakSelf = self;
    void(^succ)(id) = ^(id data) {
        __strong __typeof(weakSelf)strongSelf = weakSelf;
        //请求成功之后
        strongSelf.startDate = startDate;
        [strongSelf getLastDateFromServer:data];
    };
    void(^fail)(id) = ^(id data) {
        [IBTLoadingView hideHUDWithText:nil];
        [IBTLoadingView showTips:data];
        [self endRefreshing];
    };
    if (self.currentPage == 0) {
        [IBTLoadingView showProgressLabel:@"正在加载..."];
    }
    [[ICRHTTPController sharedController] getUserWithStartDate:startDate
     Page_number:self.currentPage page_size:100 success:succ failure:fail];
}
- (void)getLastDateFromServer:(id)data
{
    if (data) {
        NSDictionary *pageDict = data[ @"data" ][ @"paging" ];
        NSInteger pageCount = [pageDict[@"pageCount"] integerValue];
        if (pageCount <= self.currentPage) {
            [self endRefreshing];
            [IBTLoadingView hideHUDWithText:nil];
            [self fetchDataList:@"" tableStr:GXF_BASECLASS_USER];
        }else{
            self.currentPage++;
            [self getBaseDataFromServerWithStartDate:self.startDate];
        }
    }else{
        [IBTLoadingView hideHUDWithText:nil];
        [IBTLoadingView showTips:data];
    }
    
}


#pragma mark -成功
- (void)sureClick{
    if (self.isMoreChose) {
        NSMutableArray *arr = [[NSMutableArray alloc]init];
        for (NSIndexPath *index in self.indexArr) {
            User *user = self.dataArr[index.row];
            SurveyUser * survey = [[SurveyUser alloc]init];
            survey.userUuid = user.uuid;
            survey.userCode = user.login;
            survey.userName = user.name;
            [arr addObject:survey];
        }
        self.choseBaseInfo(arr);
    }else{
        NSMutableArray *arr = [[NSMutableArray alloc]init];
        if (self.dataArr.count > 0) {
            if (self.currentIndexPath) {
                User *user = self.dataArr[self.currentIndexPath.row];
                SurveyUser * survey = [[SurveyUser alloc]init];
                survey.userUuid = user.uuid;
                survey.userCode = user.login;
                survey.userName = user.name;
                [arr addObject:survey];
                self.choseBaseInfo(arr);
            }
        }
    }
    [self PopViewControllerAnimated:YES];
}

#pragma mark - 协议方法
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellID = @"MaskCell";
    MaskCell *cell = [tableView dequeueReusableCellWithIdentifier:cellID];
    if (cell == nil) {
        cell = [[MaskCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellID totalWidth:ScreenSize.width totalHeight:TableHeight];
        tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.Commitbtn.hidden = YES;
    }
    if (self.isMoreChose) {
        if ([self isHaveIndexPath:indexPath]) {
            cell.Commitbtn.hidden = NO;
            cell.titleLabel.textColor = BASESELECT_COLOR;
        }else{
            cell.Commitbtn.hidden = YES;
            cell.titleLabel.textColor = [UIColor blackColor];
        }
    }else{
        if (self.currentIndexPath) {
            if (indexPath.row == self.currentIndexPath.row) {
                cell.Commitbtn.hidden = NO;
                cell.titleLabel.textColor = BASESELECT_COLOR;
            }else{
                cell.Commitbtn.hidden = YES;
                cell.titleLabel.textColor = [UIColor blackColor];
            }
        }else{
            cell.Commitbtn.hidden = YES;
            cell.titleLabel.textColor = [UIColor blackColor];
        }
    }

    if (self.dataArr.count > 0) {
        if (indexPath.row == 0) {
            NSString *dateStr = [self.dataArr[indexPath.row] httpParameterString];
            cell.titleLabel.textColor = GXF_CONTENT_COLOR;
            [cell setTitleStr:[NSString stringWithFormat:@"上次更新时间:%@",dateStr]];
        }else{
            User *user =  self.dataArr[indexPath.row];
            [cell setTitleStr:[NSString stringWithFormat:@"%@[%@]",user.name,user.login]];
        }
    }
    return cell;
}
- (void)boxValueChanged:(NSNotification *)fication{
    NSString *tilkeStr = [IBTCommon trimmingCharacters:self.selectTextFiled.text];
    [self fetchDataList:tilkeStr tableStr:GXF_BASECLASS_USER];
}

- (void)tableViewRefresh:(NSString *)titltstr{
    if (titltstr.length > 0) {
        [super tableViewRefresh:titltstr];
    }else{
        if (self.selectArr.count > 0) {
            if (self.isMoreChose) {
                for (NSInteger i = 1;i< self.dataArr.count; i++) {
                    User *user = self.dataArr[i];
                    for (NSString * surverUuid in self.selectArr) {
                        if ([user.uuid isEqualToString:surverUuid]) {
                            NSIndexPath *indexPath = [NSIndexPath indexPathForRow:i inSection:0];
                            [self.indexArr addObject:indexPath];
                            break;
                        }
                    }
                }
            }else{
                for (NSInteger i = 1;i< self.dataArr.count; i++) {
                    User *user = self.dataArr[i];
                    for (NSString * surverUuid in self.selectArr) {
                        if ([user.uuid isEqualToString:surverUuid]) {
                            NSIndexPath *indexPath = [NSIndexPath indexPathForRow:i inSection:0];
                            self.currentIndexPath = indexPath;
                            break;
                        }
                    }
                }
            }
            [self.tableView reloadData];
        }else{
            [super tableViewRefresh:titltstr];
        }
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

@end
